%define debug_package %{nil}
%global _build_id_links	none

%if 0%{?centos}0%{?amzn} == 70 || 0%{?rhel}0%{?amzn} == 70
%define python3_pkgversion 36
%endif

%define	rel			1
%define VirtualEnvironment      %{name}-%{version}-%{rel}
%define VirtualEnvironmentPath  %{_prefix}/local/lib/PythonVirtualEnvironments

%if 0%{?centos} || 0%{?amzn}
%define __python                %(echo which python3 | scl enable rh-python38 -)
%else
%define __python                /usr/bin/python3
%endif

Name:		fakenet
Version:	3.0a
Release:	1%{?dist}
Summary:	Next generation dynamic network analysis tool for malware analysts and penetration testers
Group:		Malware Analysis
License:	APLm2
Source:		%{name}-%{version}.zip
URL:		https://github.com/mandiant/flare-fakenet-ng

%if 0%{?centos} == 9 || 0%{?rhel} == 9
%ifarch aarch64
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^libffi-2a6f5b63.so.8.1.0
%endif
%endif

%if 0%{?amzn}
BuildRequires:	rh-python36-python-virtualenv
BuildRequires:	rh-python38-python rh-python38-python-devel
BuildRequires:	rust
Requires:	rh-python38-python
%endif

%if 0%{?centos}0%{?amzn} == 70
BuildRequires:	python36-virtualenv
BuildRequires:	rh-python38-python rh-python38-python-devel
Requires:	rh-python38-python
%endif

%if 0%{?centos} == 8 || 0%{?rhel} == 8
BuildRequires:	python3.11 python3.11-devel
Requires:	python3.11
%define		__python	/usr/bin/python3.11
%endif

%if 0%{?fedora} || 0%{?centos} == 9 || 0%{?rhel} == 9
BuildRequires:	python3-devel
%define		__python	/usr/bin/python3
%endif

BuildRequires:	libnfnetlink-devel
BuildRequires:	libnetfilter_queue-devel

%description
FakeNet-NG is a next generation dynamic network analysis tool for
malware analysts and penetration testers. It is open source and designed
for the latest versions of Windows (and Linux, for certain modes of
operation). FakeNet-NG is based on the excellent Fakenet tool developed
by Andrew Honig and Michael Sikorski.

The tool allows you to intercept and redirect all or specific network
traffic while simulating legitimate network services. Using FakeNet-NG,
malware analysts can quickly identify malware's functionality and
capture network signatures. Penetration testers and bug hunters will
find FakeNet-NG's configurable interception engine and modular framework
highly useful when testing application's specific functionality and
prototyping PoCs.

%prep
%setup -c
sudo mkdir -p %{VirtualEnvironmentPath}
sudo chown %(id -u).%(id -g) %{VirtualEnvironmentPath}
cd %{VirtualEnvironmentPath}
rm -rf %{VirtualEnvironment}

%if 0%{?amzn}
echo virtualenv -p $(echo which python3.8 | scl enable rh-python38 -) %{VirtualEnvironment} | scl enable rh-python36 -
%endif

%if 0%{?centos}0%{?amzn} == 70
echo virtualenv-3 -p $(echo which python3 | scl enable rh-python38 -) %{VirtualEnvironment} | scl enable rh-python38 -
%endif

%if 0%{?fedora} || 0%{?centos} == 9 || 0%{?rhel} == 9 || 0%{?centos} == 8 || 0%{?rhel} == 8
%{__python} -m venv %{VirtualEnvironment}
%endif

%build
cd %{VirtualEnvironmentPath}/%{VirtualEnvironment}
for p in pip https://github.com/mandiant/flare-fakenet-ng/zipball/master
do
	sh -c "source bin/activate; pip3 install --upgrade \"$p\""
done

%install
%{__mkdir_p} %{buildroot}/%{VirtualEnvironmentPath}
cd %{VirtualEnvironmentPath}
rm -f %{VirtualEnvironment}/.gitignore
rsync -a --sparse %{VirtualEnvironment} %{buildroot}%{VirtualEnvironmentPath}
#rm -rf %{VirtualEnvironment}

cd %{buildroot}/%{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin
mkdir -p %{buildroot}/%{_bindir}
cat > %{buildroot}/%{_bindir}/%{name} << 'EOF'
#!/bin/sh

N=$(basename $0)
MA=%{VirtualEnvironment}
VE=%{VirtualEnvironmentPath}

if [ -d $VE ]; then
	source $VE/$MA/bin/activate
	exec python3 $VE/$MA/bin/$N "$@"
else
	echo $0 cannot be found
	exit 2
fi
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc */docs/*
%attr(0755,root,root)	%{_bindir}/%{name}
%attr(0755,root,root)	%{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin/%{name}
%attr(0755,root,root)	%{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin/ftpbench
%attr(0755,root,root)	%{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin/*pip*
%attr(0755,root,root)	%{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin/Activate.ps1
%{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin/*activate*
%{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin/python*
%{VirtualEnvironmentPath}/%{VirtualEnvironment}/lib
%{VirtualEnvironmentPath}/%{VirtualEnvironment}/lib64
%{VirtualEnvironmentPath}/%{VirtualEnvironment}/include
%{VirtualEnvironmentPath}/%{VirtualEnvironment}/pyvenv.cfg

%changelog
* Tue Mar 24 2020 Lawrence R. Rogers <lrr@cert.org> 3.0a-1
* Release 3.0a-1
	Version 3.0 alpha
